Index: branches/SpectralKernelForGaussianProcesses/HeuristicLab 3.3.sln
===================================================================
--- branches/SpectralKernelForGaussianProcesses/HeuristicLab 3.3.sln	(revision 10473)
+++ branches/SpectralKernelForGaussianProcesses/HeuristicLab 3.3.sln	(revision 10479)
@@ -112,6 +112,8 @@
 		{AB687BBE-1BFE-476B-906D-44237135431D} = {AB687BBE-1BFE-476B-906D-44237135431D}
 		{66D249C3-A01D-42A8-82A2-919BC8EC3D83} = {66D249C3-A01D-42A8-82A2-919BC8EC3D83}
+		{21977CC3-1757-4B3B-87BD-FF817AAA900F} = {21977CC3-1757-4B3B-87BD-FF817AAA900F}
 		{E4CFB0C3-0589-4893-B38E-8BEDF885C765} = {E4CFB0C3-0589-4893-B38E-8BEDF885C765}
 		{E6CB1FC5-78EC-4EB8-BF12-35303C36F962} = {E6CB1FC5-78EC-4EB8-BF12-35303C36F962}
+		{0C2917C8-7AA8-4E18-800A-C4D064F992ED} = {0C2917C8-7AA8-4E18-800A-C4D064F992ED}
 		{79271BC8-4446-40E2-BB89-9BE4E17174FE} = {79271BC8-4446-40E2-BB89-9BE4E17174FE}
 		{7A2531CE-3F7C-4F13-BCCA-ED6DC27A7086} = {7A2531CE-3F7C-4F13-BCCA-ED6DC27A7086}
@@ -381,4 +383,8 @@
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Problems.DataAnalysis.Trading.Views-3.4", "HeuristicLab.Problems.DataAnalysis.Trading.Views\3.4\HeuristicLab.Problems.DataAnalysis.Trading.Views-3.4.csproj", "{CB3D0A1E-1BE8-476B-A53C-2B189E30064F}"
+EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.HLScript-3.3", "HeuristicLab.HLScript\3.3\HeuristicLab.HLScript-3.3.csproj", "{21977CC3-1757-4B3B-87BD-FF817AAA900F}"
+EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.HLScript.Views-3.3", "HeuristicLab.HLScript.Views\3.3\HeuristicLab.HLScript.Views-3.3.csproj", "{0C2917C8-7AA8-4E18-800A-C4D064F992ED}"
 EndProject
 Global
@@ -1856,4 +1862,28 @@
 		{CB3D0A1E-1BE8-476B-A53C-2B189E30064F}.Release|x86.ActiveCfg = Release|x86
 		{CB3D0A1E-1BE8-476B-A53C-2B189E30064F}.Release|x86.Build.0 = Release|x86
+		{21977CC3-1757-4B3B-87BD-FF817AAA900F}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{21977CC3-1757-4B3B-87BD-FF817AAA900F}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{21977CC3-1757-4B3B-87BD-FF817AAA900F}.Debug|x64.ActiveCfg = Debug|x64
+		{21977CC3-1757-4B3B-87BD-FF817AAA900F}.Debug|x64.Build.0 = Debug|x64
+		{21977CC3-1757-4B3B-87BD-FF817AAA900F}.Debug|x86.ActiveCfg = Debug|x86
+		{21977CC3-1757-4B3B-87BD-FF817AAA900F}.Debug|x86.Build.0 = Debug|x86
+		{21977CC3-1757-4B3B-87BD-FF817AAA900F}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{21977CC3-1757-4B3B-87BD-FF817AAA900F}.Release|Any CPU.Build.0 = Release|Any CPU
+		{21977CC3-1757-4B3B-87BD-FF817AAA900F}.Release|x64.ActiveCfg = Release|x64
+		{21977CC3-1757-4B3B-87BD-FF817AAA900F}.Release|x64.Build.0 = Release|x64
+		{21977CC3-1757-4B3B-87BD-FF817AAA900F}.Release|x86.ActiveCfg = Release|x86
+		{21977CC3-1757-4B3B-87BD-FF817AAA900F}.Release|x86.Build.0 = Release|x86
+		{0C2917C8-7AA8-4E18-800A-C4D064F992ED}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{0C2917C8-7AA8-4E18-800A-C4D064F992ED}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{0C2917C8-7AA8-4E18-800A-C4D064F992ED}.Debug|x64.ActiveCfg = Debug|x64
+		{0C2917C8-7AA8-4E18-800A-C4D064F992ED}.Debug|x64.Build.0 = Debug|x64
+		{0C2917C8-7AA8-4E18-800A-C4D064F992ED}.Debug|x86.ActiveCfg = Debug|x86
+		{0C2917C8-7AA8-4E18-800A-C4D064F992ED}.Debug|x86.Build.0 = Debug|x86
+		{0C2917C8-7AA8-4E18-800A-C4D064F992ED}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{0C2917C8-7AA8-4E18-800A-C4D064F992ED}.Release|Any CPU.Build.0 = Release|Any CPU
+		{0C2917C8-7AA8-4E18-800A-C4D064F992ED}.Release|x64.ActiveCfg = Release|x64
+		{0C2917C8-7AA8-4E18-800A-C4D064F992ED}.Release|x64.Build.0 = Release|x64
+		{0C2917C8-7AA8-4E18-800A-C4D064F992ED}.Release|x86.ActiveCfg = Release|x86
+		{0C2917C8-7AA8-4E18-800A-C4D064F992ED}.Release|x86.Build.0 = Release|x86
 	EndGlobalSection
 	GlobalSection(SolutionProperties) = preSolution
Index: branches/SpectralKernelForGaussianProcesses/HeuristicLab.Algorithms.OffspringSelectionGeneticAlgorithm/3.3/SuccessfulOffspringAnalysis/SuccessfulOffspringAnalyzer.cs
===================================================================
--- branches/SpectralKernelForGaussianProcesses/HeuristicLab.Algorithms.OffspringSelectionGeneticAlgorithm/3.3/SuccessfulOffspringAnalysis/SuccessfulOffspringAnalyzer.cs	(revision 10473)
+++ branches/SpectralKernelForGaussianProcesses/HeuristicLab.Algorithms.OffspringSelectionGeneticAlgorithm/3.3/SuccessfulOffspringAnalysis/SuccessfulOffspringAnalyzer.cs	(revision 10479)
@@ -81,4 +81,7 @@
       Parameters.Add(new LookupParameter<ResultCollection>("SuccessfulOffspringAnalysis", "The successful offspring analysis which is created."));
       Parameters.Add(new ValueParameter<IntValue>("Depth", "The depth of the individuals in the scope tree.", new IntValue(1)));
+
+      CollectedValuesParameter.Value.Add(new StringValue("SelectedCrossoverOperator"));
+      CollectedValuesParameter.Value.Add(new StringValue("SelectedManipulationOperator"));
     }
 
@@ -110,57 +113,59 @@
         }
 
-        //create a data table containing the collected values
-        ResultCollection successfulOffspringAnalysis;
+        if (counts.Count > 0) {
+          //create a data table containing the collected values
+          ResultCollection successfulOffspringAnalysis;
 
-        if (SuccessfulOffspringAnalysisParameter.ActualValue == null) {
-          successfulOffspringAnalysis = new ResultCollection();
-          SuccessfulOffspringAnalysisParameter.ActualValue = successfulOffspringAnalysis;
-        } else {
-          successfulOffspringAnalysis = SuccessfulOffspringAnalysisParameter.ActualValue;
-        }
-
-        string resultKey = "SuccessfulOffspringAnalyzer Results";
-        if (!results.ContainsKey(resultKey)) {
-          results.Add(new Result(resultKey, successfulOffspringAnalysis));
-        } else {
-          results[resultKey].Value = successfulOffspringAnalysis;
-        }
-
-        DataTable successProgressAnalysis;
-        if (!successfulOffspringAnalysis.ContainsKey(collected.Value)) {
-          successProgressAnalysis = new DataTable();
-          successProgressAnalysis.Name = collected.Value;
-          successfulOffspringAnalysis.Add(new Result(collected.Value, successProgressAnalysis));
-        } else {
-          successProgressAnalysis = successfulOffspringAnalysis[collected.Value].Value as DataTable;
-        }
-
-        int successfulCount = 0;
-        foreach (string key in counts.Keys) {
-          successfulCount += counts[key];
-        }
-
-        foreach (String value in counts.Keys) {
-          DataRow row;
-          if (!successProgressAnalysis.Rows.ContainsKey(value)) {
-            row = new DataRow(value);
-            int iterations = GenerationsParameter.ActualValue.Value;
-
-            //fill up all values seen the first time
-            for (int i = 1; i < iterations; i++)
-              row.Values.Add(0);
-
-            successProgressAnalysis.Rows.Add(row);
+          if (SuccessfulOffspringAnalysisParameter.ActualValue == null) {
+            successfulOffspringAnalysis = new ResultCollection();
+            SuccessfulOffspringAnalysisParameter.ActualValue = successfulOffspringAnalysis;
           } else {
-            row = successProgressAnalysis.Rows[value];
+            successfulOffspringAnalysis = SuccessfulOffspringAnalysisParameter.ActualValue;
           }
 
-          row.Values.Add(counts[value] / (double)successfulCount);
-        }
+          string resultKey = "SuccessfulOffspringAnalyzer Results";
+          if (!results.ContainsKey(resultKey)) {
+            results.Add(new Result(resultKey, successfulOffspringAnalysis));
+          } else {
+            results[resultKey].Value = successfulOffspringAnalysis;
+          }
 
-        //fill up all values that are not present in the current generation
-        foreach (DataRow row in successProgressAnalysis.Rows) {
-          if (!counts.ContainsKey(row.Name))
-            row.Values.Add(0);
+          DataTable successProgressAnalysis;
+          if (!successfulOffspringAnalysis.ContainsKey(collected.Value)) {
+            successProgressAnalysis = new DataTable();
+            successProgressAnalysis.Name = collected.Value;
+            successfulOffspringAnalysis.Add(new Result(collected.Value, successProgressAnalysis));
+          } else {
+            successProgressAnalysis = successfulOffspringAnalysis[collected.Value].Value as DataTable;
+          }
+
+          int successfulCount = 0;
+          foreach (string key in counts.Keys) {
+            successfulCount += counts[key];
+          }
+
+          foreach (String value in counts.Keys) {
+            DataRow row;
+            if (!successProgressAnalysis.Rows.ContainsKey(value)) {
+              row = new DataRow(value);
+              int iterations = GenerationsParameter.ActualValue.Value;
+
+              //fill up all values seen the first time
+              for (int i = 1; i < iterations; i++)
+                row.Values.Add(0);
+
+              successProgressAnalysis.Rows.Add(row);
+            } else {
+              row = successProgressAnalysis.Rows[value];
+            }
+
+            row.Values.Add(counts[value] / (double)successfulCount);
+          }
+
+          //fill up all values that are not present in the current generation
+          foreach (DataRow row in successProgressAnalysis.Rows) {
+            if (!counts.ContainsKey(row.Name))
+              row.Values.Add(0);
+          }
         }
       }
Index: branches/SpectralKernelForGaussianProcesses/HeuristicLab.Analysis/3.3/MultiAnalyzer.cs
===================================================================
--- branches/SpectralKernelForGaussianProcesses/HeuristicLab.Analysis/3.3/MultiAnalyzer.cs	(revision 10473)
+++ branches/SpectralKernelForGaussianProcesses/HeuristicLab.Analysis/3.3/MultiAnalyzer.cs	(revision 10479)
@@ -69,5 +69,5 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation InstrumentedApply() {
       IntValue interval = UpdateIntervalParameter.ActualValue;
       if (interval == null) interval = new IntValue(1);
@@ -84,8 +84,8 @@
         foreach (IndexedItem<IAnalyzer> item in Operators.CheckedItems)
           next.Add(ExecutionContext.CreateOperation(item.Value));
-        next.Add(base.Apply());
+        next.Add(base.InstrumentedApply());
         return next;
       } else {
-        return base.Apply();
+        return base.InstrumentedApply();
       }
     }
Index: branches/SpectralKernelForGaussianProcesses/HeuristicLab.Clients.Hive.Views/3.3/HiveTasks/HiveTaskView.cs
===================================================================
--- branches/SpectralKernelForGaussianProcesses/HeuristicLab.Clients.Hive.Views/3.3/HiveTasks/HiveTaskView.cs	(revision 10473)
+++ branches/SpectralKernelForGaussianProcesses/HeuristicLab.Clients.Hive.Views/3.3/HiveTasks/HiveTaskView.cs	(revision 10479)
@@ -96,5 +96,5 @@
             this.priorityComboBox.SelectedIndex = Content.Task.Priority;
           } else {
-            this.priorityComboBox.SelectedIndex = 0;
+            this.priorityComboBox.SelectedIndex = 1;
           }
           this.coresNeededComboBox.Text = Content.Task.CoresNeeded.ToString();
@@ -103,5 +103,5 @@
           this.jobIdTextBox.Text = string.Empty;
           this.dateCreatedTextBox.Text = string.Empty;
-          this.priorityComboBox.SelectedIndex = 0;
+          this.priorityComboBox.SelectedIndex = 1;
           this.coresNeededComboBox.Text = "1";
           this.memoryNeededComboBox.Text = "128";
Index: branches/SpectralKernelForGaussianProcesses/HeuristicLab.Clients.Hive.Views/3.3/HiveTasks/HiveTaskView.designer.cs
===================================================================
--- branches/SpectralKernelForGaussianProcesses/HeuristicLab.Clients.Hive.Views/3.3/HiveTasks/HiveTaskView.designer.cs	(revision 10473)
+++ branches/SpectralKernelForGaussianProcesses/HeuristicLab.Clients.Hive.Views/3.3/HiveTasks/HiveTaskView.designer.cs	(revision 10479)
@@ -109,7 +109,7 @@
       // stateLogViewHost
       // 
-      this.stateLogViewHost.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
-                  | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.stateLogViewHost.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
       this.stateLogViewHost.Caption = "View";
       this.stateLogViewHost.Content = null;
@@ -137,6 +137,6 @@
       // splitContainer1
       // 
-      this.splitContainer1.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.splitContainer1.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
       this.splitContainer1.Location = new System.Drawing.Point(6, 6);
       this.splitContainer1.Name = "splitContainer1";
@@ -189,9 +189,10 @@
       // priorityComboBox
       // 
-      this.priorityComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.priorityComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
       this.priorityComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
       this.priorityComboBox.FormattingEnabled = true;
       this.priorityComboBox.Items.AddRange(new object[] {
+            "Low",
             "Normal",
             "Urgent",
@@ -214,6 +215,6 @@
       // jobIdTextBox
       // 
-      this.jobIdTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.jobIdTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
       this.jobIdTextBox.Location = new System.Drawing.Point(87, 13);
       this.jobIdTextBox.Name = "jobIdTextBox";
@@ -232,6 +233,6 @@
       // lastUpdatedTextBox
       // 
-      this.lastUpdatedTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.lastUpdatedTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
       this.lastUpdatedTextBox.Location = new System.Drawing.Point(87, 66);
       this.lastUpdatedTextBox.Name = "lastUpdatedTextBox";
@@ -266,6 +267,6 @@
       // memoryNeededComboBox
       // 
-      this.memoryNeededComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.memoryNeededComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
       this.memoryNeededComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
       this.memoryNeededComboBox.FormattingEnabled = true;
@@ -283,6 +284,6 @@
       // coresNeededComboBox
       // 
-      this.coresNeededComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.coresNeededComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
       this.coresNeededComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
       this.coresNeededComboBox.FormattingEnabled = true;
@@ -360,6 +361,6 @@
       // commandTextBox
       // 
-      this.commandTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.commandTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
       this.commandTextBox.Location = new System.Drawing.Point(95, 39);
       this.commandTextBox.Name = "commandTextBox";
@@ -378,6 +379,6 @@
       // stateTextBox
       // 
-      this.stateTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.stateTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
       this.stateTextBox.Location = new System.Drawing.Point(95, 13);
       this.stateTextBox.Name = "stateTextBox";
@@ -405,6 +406,6 @@
       // dateCalculatedText
       // 
-      this.dateCalculatedText.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.dateCalculatedText.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
       this.dateCalculatedText.Location = new System.Drawing.Point(95, 117);
       this.dateCalculatedText.Name = "dateCalculatedText";
@@ -414,6 +415,6 @@
       // dateFinishedTextBox
       // 
-      this.dateFinishedTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.dateFinishedTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
       this.dateFinishedTextBox.Location = new System.Drawing.Point(95, 143);
       this.dateFinishedTextBox.Name = "dateFinishedTextBox";
@@ -423,6 +424,6 @@
       // executionTimeTextBox
       // 
-      this.executionTimeTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.executionTimeTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
       this.executionTimeTextBox.Location = new System.Drawing.Point(95, 65);
       this.executionTimeTextBox.Name = "executionTimeTextBox";
@@ -432,6 +433,6 @@
       // dateCreatedTextBox
       // 
-      this.dateCreatedTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.dateCreatedTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
       this.dateCreatedTextBox.Location = new System.Drawing.Point(95, 91);
       this.dateCreatedTextBox.Name = "dateCreatedTextBox";
@@ -477,6 +478,6 @@
       // exceptionTextBox
       // 
-      this.exceptionTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.exceptionTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
       this.exceptionTextBox.Location = new System.Drawing.Point(95, 169);
       this.exceptionTextBox.Name = "exceptionTextBox";
@@ -487,6 +488,6 @@
       // modifyItemButton
       // 
-      this.modifyItemButton.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.modifyItemButton.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
       this.modifyItemButton.Location = new System.Drawing.Point(3, 224);
       this.modifyItemButton.Name = "modifyItemButton";
@@ -499,7 +500,7 @@
       // tabControl
       // 
-      this.tabControl.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
-                  | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.tabControl.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
       this.tabControl.Controls.Add(this.detailsTabPage);
       this.tabControl.Controls.Add(this.stateLogTabPage);
@@ -512,5 +513,4 @@
       // HiveTaskView
       // 
-      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Inherit;
       this.Controls.Add(this.tabControl);
Index: branches/SpectralKernelForGaussianProcesses/HeuristicLab.Clients.Hive/3.3/ServiceClients/Task.cs
===================================================================
--- branches/SpectralKernelForGaussianProcesses/HeuristicLab.Clients.Hive/3.3/ServiceClients/Task.cs	(revision 10473)
+++ branches/SpectralKernelForGaussianProcesses/HeuristicLab.Clients.Hive/3.3/ServiceClients/Task.cs	(revision 10479)
@@ -27,5 +27,7 @@
   public partial class Task : LightweightTask {
 
-    public Task() { }
+    public Task() {
+      Priority = 1;
+    }
 
     protected Task(Task original, Cloner cloner)
Index: branches/SpectralKernelForGaussianProcesses/HeuristicLab.CodeEditor/3.3/CodeEditor.cs
===================================================================
--- branches/SpectralKernelForGaussianProcesses/HeuristicLab.CodeEditor/3.3/CodeEditor.cs	(revision 10473)
+++ branches/SpectralKernelForGaussianProcesses/HeuristicLab.CodeEditor/3.3/CodeEditor.cs	(revision 10479)
@@ -140,4 +140,11 @@
       if (TextEditorValidated != null)
         TextEditorValidated(this, EventArgs.Empty);
+    }
+
+    public event EventHandler TextEditorTextChanged;
+
+    protected void OnTextEditorTextChanged() {
+      if (TextEditorTextChanged != null)
+        TextEditorTextChanged(this, EventArgs.Empty);
     }
 
@@ -188,4 +195,5 @@
 
       textEditor.Validated += (s, a) => { OnTextEditorValidated(); };
+      textEditor.TextChanged += (s, a) => { OnTextEditorTextChanged(); };
       InitializeImageList();
     }
@@ -298,19 +306,19 @@
     public void AddAssembly(Assembly a) {
       ShowMessage("Loading " + a.GetName().Name + "...");
-      if (assemblies.Contains(a))
-        return;
-      var reference = projectContentRegistry.GetProjectContentForReference(a.GetName().Name, a.Location);
-      projectContent.AddReferencedContent(reference);
-      assemblies.Add(a);
+      if (!assemblies.Contains(a)) {
+        var reference = projectContentRegistry.GetProjectContentForReference(a.GetName().Name, a.Location);
+        projectContent.AddReferencedContent(reference);
+        assemblies.Add(a);
+      }
       ShowMessage("Ready");
     }
     public void RemoveAssembly(Assembly a) {
       ShowMessage("Unloading " + a.GetName().Name + "...");
-      if (!assemblies.Contains(a))
-        return;
-      var content = projectContentRegistry.GetExistingProjectContent(a.Location);
-      if (content != null) {
-        projectContent.ReferencedContents.Remove(content);
-        projectContentRegistry.UnloadProjectContent(content);
+      if (assemblies.Contains(a)) {
+        var content = projectContentRegistry.GetExistingProjectContent(a.Location);
+        if (content != null) {
+          projectContent.ReferencedContents.Remove(content);
+          projectContentRegistry.UnloadProjectContent(content);
+        }
       }
       ShowMessage("Ready");
Index: branches/SpectralKernelForGaussianProcesses/HeuristicLab.Collections/3.3/BidirectionalDictionary.cs
===================================================================
--- branches/SpectralKernelForGaussianProcesses/HeuristicLab.Collections/3.3/BidirectionalDictionary.cs	(revision 10473)
+++ branches/SpectralKernelForGaussianProcesses/HeuristicLab.Collections/3.3/BidirectionalDictionary.cs	(revision 10479)
@@ -67,9 +67,9 @@
     }
 
-    public IEnumerable<TFirst> FirstValues {
+    public IEnumerable<TFirst> FirstKeys {
       get { return firstToSecond.Keys; }
     }
 
-    public IEnumerable<TSecond> SecondValues {
+    public IEnumerable<TSecond> SecondKeys {
       get { return secondToFirst.Keys; }
     }
Index: branches/SpectralKernelForGaussianProcesses/HeuristicLab.Collections/3.3/BidirectionalLookup.cs
===================================================================
--- branches/SpectralKernelForGaussianProcesses/HeuristicLab.Collections/3.3/BidirectionalLookup.cs	(revision 10473)
+++ branches/SpectralKernelForGaussianProcesses/HeuristicLab.Collections/3.3/BidirectionalLookup.cs	(revision 10479)
@@ -62,10 +62,10 @@
     }
 
-    public IEnumerable<IEnumerable<TSecond>> FirstValues {
-      get { return firstToSecond.Values.AsEnumerable(); }
-    }
-
-    public IEnumerable<IEnumerable<TFirst>> SecondValues {
-      get { return secondToFirst.Values.AsEnumerable(); }
+    public IEnumerable<TFirst> FirstKeys {
+      get { return firstToSecond.Keys.AsEnumerable(); }
+    }
+
+    public IEnumerable<TSecond> SecondKeys {
+      get { return secondToFirst.Keys.AsEnumerable(); }
     }
 
Index: branches/SpectralKernelForGaussianProcesses/HeuristicLab.Collections/3.3/HeuristicLab.Collections-3.3.csproj
===================================================================
--- branches/SpectralKernelForGaussianProcesses/HeuristicLab.Collections/3.3/HeuristicLab.Collections-3.3.csproj	(revision 10473)
+++ branches/SpectralKernelForGaussianProcesses/HeuristicLab.Collections/3.3/HeuristicLab.Collections-3.3.csproj	(revision 10479)
@@ -157,4 +157,8 @@
   </ItemGroup>
   <ItemGroup>
+    <ProjectReference Include="..\..\HeuristicLab.Common\3.3\HeuristicLab.Common-3.3.csproj">
+      <Project>{A9AD58B9-3EF9-4CC1-97E5-8D909039FF5C}</Project>
+      <Name>HeuristicLab.Common-3.3</Name>
+    </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Persistence\3.3\HeuristicLab.Persistence-3.3.csproj">
       <Project>{102BC7D3-0EF9-439C-8F6D-96FF0FDB8E1B}</Project>
Index: branches/SpectralKernelForGaussianProcesses/HeuristicLab.Collections/3.3/ObservableArray.cs
===================================================================
--- branches/SpectralKernelForGaussianProcesses/HeuristicLab.Collections/3.3/ObservableArray.cs	(revision 10473)
+++ branches/SpectralKernelForGaussianProcesses/HeuristicLab.Collections/3.3/ObservableArray.cs	(revision 10479)
@@ -25,4 +25,5 @@
 using System.ComponentModel;
 using System.Linq;
+using HeuristicLab.Common;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
@@ -168,5 +169,5 @@
         Array.Clear(array, index, length);
         OnPropertyChanged("Item[]");
-        OnItemsReplaced(GetIndexedItems(index, length), oldItems); 
+        OnItemsReplaced(GetIndexedItems(index, length), oldItems);
       }
     }
@@ -205,5 +206,5 @@
       if (array.Length > 1) {
         IndexedItem<T>[] oldItems = GetIndexedItems();
-        Array.Sort<T>(array);
+        array.StableSort();
         OnPropertyChanged("Item[]");
         OnItemsMoved(GetIndexedItems(), oldItems);
@@ -213,5 +214,5 @@
       if (array.Length > 1) {
         IndexedItem<T>[] oldItems = GetIndexedItems();
-        Array.Sort<T>(array, comparison);
+        array.StableSort(comparison);
         OnPropertyChanged("Item[]");
         OnItemsMoved(GetIndexedItems(), oldItems);
@@ -221,5 +222,5 @@
       if (array.Length > 1) {
         IndexedItem<T>[] oldItems = GetIndexedItems();
-        Array.Sort<T>(array, comparer);
+        array.StableSort(comparer);
         OnPropertyChanged("Item[]");
         OnItemsMoved(GetIndexedItems(), oldItems);
@@ -229,5 +230,5 @@
       if (length > 1) {
         IndexedItem<T>[] oldItems = GetIndexedItems(index, length);
-        Array.Sort<T>(array, index, length);
+        array.StableSort(index, length);
         OnPropertyChanged("Item[]");
         OnItemsMoved(GetIndexedItems(index, length), oldItems);
@@ -237,5 +238,5 @@
       if (length > 1) {
         IndexedItem<T>[] oldItems = GetIndexedItems(index, length);
-        Array.Sort<T>(array, index, length, comparer);
+        array.StableSort(index, length, comparer);
         OnPropertyChanged("Item[]");
         OnItemsMoved(GetIndexedItems(index, length), oldItems);
Index: branches/SpectralKernelForGaussianProcesses/HeuristicLab.Collections/3.3/ObservableList.cs
===================================================================
--- branches/SpectralKernelForGaussianProcesses/HeuristicLab.Collections/3.3/ObservableList.cs	(revision 10473)
+++ branches/SpectralKernelForGaussianProcesses/HeuristicLab.Collections/3.3/ObservableList.cs	(revision 10479)
@@ -25,4 +25,5 @@
 using System.ComponentModel;
 using System.Linq;
+using HeuristicLab.Common;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
@@ -320,5 +321,5 @@
       if (list.Count > 1) {
         IndexedItem<T>[] oldItems = GetIndexedItems();
-        list.Sort();
+        list.StableSort();
         OnItemsMoved(GetIndexedItems(), oldItems);
         OnPropertyChanged("Item[]");
@@ -328,5 +329,5 @@
       if (list.Count > 1) {
         IndexedItem<T>[] oldItems = GetIndexedItems();
-        list.Sort(comparison);
+        list.StableSort(comparison);
         OnItemsMoved(GetIndexedItems(), oldItems);
         OnPropertyChanged("Item[]");
@@ -336,5 +337,5 @@
       if (list.Count > 1) {
         IndexedItem<T>[] oldItems = GetIndexedItems();
-        list.Sort(comparer);
+        list.StableSort(comparer);
         OnItemsMoved(GetIndexedItems(), oldItems);
         OnPropertyChanged("Item[]");
@@ -344,5 +345,5 @@
       if (count > 1) {
         IndexedItem<T>[] oldItems = GetIndexedItems(index, count);
-        list.Sort(index, count, comparer);
+        list.StableSort(index, count, comparer);
         OnItemsMoved(GetIndexedItems(index, count), oldItems);
         OnPropertyChanged("Item[]");
